import { Injectable } from '@angular/core';
import {
  Client,
  ClientNotificationCodec,
  WebSocketClientRWC,
  WebSocketClientRWCConfig,
  JSONClientCodec
} from '@overflow/rpc-js';
import { Subscription } from 'rxjs';

export const requesterID = 'scannerUser';

const config: WebSocketClientRWCConfig = {
  url: 'ws://localhost:60000/scanner?requesterID=' + requesterID
};
const rwc = new WebSocketClientRWC(config);
const codec = new JSONClientCodec();

@Injectable({
  providedIn: 'root'
})
export class ProbeService extends Client {
  private notiSubscription: Subscription;

  public constructor() {
    super(codec, rwc);

    this.connect();

    this.notiSubscription = this.notification()
      .subscribe((notiCodec: ClientNotificationCodec) => {
        console.log(notiCodec.method());
        const params = notiCodec.params();
        if (undefined !== params) {
          params.forEach(param => {

            console.log(param);
          });
        }
      });
    this.connectionStatus().subscribe(isConnected => {
      if (!isConnected) {
        console.log('disconnected');
      } else {
        console.log('connected');
      }
    });
  }
}
